CON
  _clkmode    = xtal1 + pll16x
  _xinfreq    = 5_000_000

  #0
  OP_RESULT
  OP_ADD
  OP_SUB
  
OBJ
  pkt : "packet_driver"

VAR
  long type
  long buffer[4]
  long length

PUB main | sts

  outa[23..16] := %1000_0100
  dira[23..16] := %0000_0111

  pkt.start(31, 30, 115200)

  repeat

    length := 16
    sts := pkt.rx(@type, @buffer, @length)
  
    if sts == 0
      case type
        OP_ADD:
          outa[17..16] := %01
          buffer[0] := buffer[0] + buffer[1]
        OP_SUB:
          outa[17..16] := %10
          buffer[0] := buffer[0] - buffer[1]
        other:
          outa[17..16] := %11
          buffer[0] := $deadbeef
    else
      outa[23] := 1

    pkt.tx(OP_RESULT, @buffer, length)
